/*
 * type.c - a program to type files for V
 *
 * Fixed up by Bill Nowicki December 1982
 *
 * Fixed up again -- RJN -- 9/8/83
 */

# include <Vio.h>
# include <Vgts.h>

# define BUFSIZE 2000		/* max chars per line */
# define LinesPerPage 26	/* lines per page */

# define INVERT_MODE	"\033[1m"
# define NORMAL_MODE	"\033[0m"
# define ERASE_TO_EOL	"\033K"

main(argc,argv)
int argc;
char **argv;
  {
    Message Msg;
    char fileName[128];
    SystemCode error;
    static char charBuffer[BUFSIZE];
    File *f;
    char ch;
    int line;
    int MoreThanOne;
    int Quit;
    int VgtsPresent;

    if (--argc < 1) 
      {
        printf("Filename: ");
	Flush(stdout);
        gets(fileName);
	if (strlen(fileName)) argc++;
      }
    else
      {
	strcpy(fileName,*++argv);
      }
   
if ( VgtsPresent = (GetPid( VGT_SERVER, LOCAL_PID) == FileServer( stdin ) ) )
    ModifyPad( stdin, LF_Output + CR_Input );
Quit = 0;
	  
MoreThanOne = argc > 1;

line = 0;
for(;;)
  {
    if ( MoreThanOne ) 
      {
	if ( VgtsPresent ) 
            printf("\n%sFile: %s%s\n", INVERT_MODE, fileName, NORMAL_MODE );
	else
            printf("\nFile: %s\n", fileName );
        Flush(stdout);
	line++;
      }
    f = Open( fileName, FREAD, &error);
    if (error || (f == NULL)) 
	printf("Open error: %s\n",ErrorString(error));
    else 
     {
      while ( !Quit && fgets(charBuffer,BUFSIZE,f) != 0 && f->state==OK) 
       {
        fputs(charBuffer,stdout);
	if (line++ >= LinesPerPage)
	  {
	    Quit = Next( VgtsPresent, "Page", "", &line );
	   }
      }
      Close(f);
    }
   if (--argc < 1 || Quit)
       break;
   if ( Next( VgtsPresent, "File: ", *++argv, &line ) == 1 )
       break;
   strcpy(fileName ,*argv);

  }

  }

Next( VgtsPresent, Word, Name, Line )
    int VgtsPresent;
    char *Word;
    char *Name;
    int *Line;
  {
    int Answer = 0;

    if ( VgtsPresent )
	printf( "%sNext %s%s%s", INVERT_MODE, Word, Name, NORMAL_MODE );
    else
	printf( "--Next %s%s--", Word, Name );
    Flush(stdout);
    switch (getchar())
      {
	case 'q':
	case 'Q':
	case 3:	/* '^c' */
	     Answer = 1;
	     break;
	case '\n':
	     *Line = LinesPerPage;
	     break;
	default:
	     *Line = 0;
	     break;
      }
     if ( VgtsPresent )
	 printf( "\r%s", ERASE_TO_EOL );
     else
	 printf( "\r                                                                           \r" );
    return( Answer );
  }
