/*
 * V Kernel I/O - Copyright (c) 1982 by David Cheriton
 * (Transliterated from Zed and Verex I/O system)
 *
 * BytePosition
 */
#include "Vio.h"

BytePosition( file )
  register File *file;

  /* Return the current byte position for the specified file */
  {
    unsigned block, index;

    block = file->block;

    if( file->type & FBLOCK_MODE ) index = 0;
    else
	if( file->writeindex != MAXUNSIGNED ) index = file->writeindex;
    else
	if( file->readindex != MAXUNSIGNED ) index = file->readindex;
    else
      {
	block = file->tempblock;
	index = file->tempindex;
      }
    return( block*(file->blocksize) + index );
  }
