/*
 * V Kernel I/O - Copyright (c) 1982 by David Cheriton
 * (Transliterated from Zed and Verex I/O system)
 *
 * Flush
 */

#include "Vioprotocol.h"


Flush( fad ) register File *fad;

  /* Flush the specified fad.
   * This writes out the contents of the buffer but does not
   * change the current byte position in the file.
   */
  {
    if ( fad->type & FBLOCK_MODE ||
       (fad->writeindex==MAXUNSIGNED) && !(fad->state&MODIFIED_BUFFER) )
	return;

    Seek( fad, 0, FLUSH );

    /* Reset the write index for stream files so they continue
     * in the next block.
     */
    if ( fad->type & STREAM )
	fad->tempindex = fad->blocksize;
  }

