/*
 * V Kernel I/O - Copyright (c) 1982 by David Cheriton
 * (Transliterated from Zed and Verex I/O system)
 *
 * Open
 */

#include "Vioprotocol.h"
#include "Vteams.h"
#include "Vnaming.h"

File *Open( pathname, mode, error ) char *pathname; short mode;
					SystemCode *error;

  /* Open the file indicated by the string pathname
   * with the specified mode.
   * FREAD - reading.
   * FCREATE - create a new instance for writing.
   * FAPPEND - append
   * FMODIFY
   * FBLOCK_MODE - do not allocate a buffer.
   */
  {
    CreateInstanceRequest request;
    ProcessId pid;

    request.requestcode = CREATE_INSTANCE;
    request.filename = pathname;
    request.filenamelen = strlen( pathname );
    request.filenameindex = 0; /* Use the entire pathname */

    mode |= FRELEASE_ON_CLOSE;

    /* Send to local name server if context specified,
     *  else to current file server */
    pid = DirectToCurrentContext(&request);

    return( _Open( &request, mode, pid, error ) );
  }
